// define surface 
SDL_Surface *temp_screen = NULL;
SDL_Surface *game_background = NULL;

//draw splash screen
void draw_Splash_screen(SDL_Surface* screen)
      {
      //load image to memory                               
      temp_screen = SDL_LoadBMP("Splash_screen3.bmp");

      SDL_Rect dest;
      dest.x = 0;
      dest.y = 0;
      
      SDL_BlitSurface(temp_screen, NULL, screen, &dest);
      
      //update screen 
      SDL_Flip(screen);
      
      //delay 
      SDL_Delay(1000);
      
      // Free the memory allocated to temp_screen
      SDL_FreeSurface(temp_screen);
      }

//draw Game background (the main board)
void draw_game_background(int track_num_image,SDL_Surface* screen)
      {
      //load image to memory 
      if (track_num_image == 0)
      game_background = SDL_LoadBMP("game_background3h.bmp");
      else if (track_num_image == 1)
      game_background = SDL_LoadBMP("game_background3z.bmp");
      else if (track_num_image == 2)
      game_background = SDL_LoadBMP("game_background3v.bmp");
      
      SDL_Rect dest;
      dest.x = 0;
      dest.y = 0;
      



      SDL_BlitSurface(game_background, NULL, screen, &dest);
      //update screen 
      SDL_Flip(screen);
      
      // Free the memory allocated to temp_screen
      SDL_FreeSurface(game_background);
      }

//draw good bye massge       
void draw_Goodbye(SDL_Surface* screen)
    {
    temp_screen = SDL_LoadBMP("Goodbye.bmp");
      
    SDL_Rect dest;
    dest.x = 0;
    dest.y = 0;
      
    SDL_BlitSurface(temp_screen, NULL, screen, &dest);
    
    //update screen  
    SDL_Flip(screen);
    
    // Free the memory allocated to temp_screen
    SDL_FreeSurface(temp_screen);
    }
    
void draw_table_of_contant(SDL_Surface* screen)
    {
    temp_screen = SDL_LoadBMP("table_of_contant1.bmp");
      
    SDL_Rect dest;
    dest.x = 0;
    dest.y = 0;
      
    SDL_BlitSurface(temp_screen, NULL, screen, &dest);
    
    //update screen   
    SDL_Flip(screen);
    
    // Free the memory allocated to temp_screen
    SDL_FreeSurface(temp_screen);
    }
// draw dice    
void draw_dice(SDL_Surface* screen, int dice_face, int dice_location_x)
    {
    temp_screen = SDL_LoadBMP("dice.bmp");
      
    SDL_Rect dice_dest;
    dice_dest.x = dice_location_x;
    dice_dest.y = 5;

    SDL_Rect  dice_image;
    dice_image.x =(dice_face -1)* 30;
    dice_image.y = 0;
    dice_image.w = 30;
    dice_image.h = 30;
  
    SDL_BlitSurface(temp_screen, &dice_image, screen, &dice_dest);
    
    //update screen   
    SDL_Flip(screen);
    
    // Free the memory allocated to temp_screen
    SDL_FreeSurface(temp_screen);
    }

//draw tile       
void draw_tile(SDL_Surface* screen,int tile_number)
      {
      //load image to memory 
      temp_screen = SDL_LoadBMP("list1.bmp");
      
      SDL_Rect dest;
      dest.x = 100;
      dest.y = 60;
      
      SDL_Rect  tile_image;
      tile_image.x = 120*tile_number;
      tile_image.y = 0;
      tile_image.w = 120;
      tile_image.h = 120;
      
      Uint32 colorkey = SDL_MapRGB( temp_screen->format, 0, 0, 0 );

      SDL_SetColorKey(temp_screen,SDL_SRCCOLORKEY, colorkey );
      
      SDL_BlitSurface(temp_screen, &tile_image, screen, &dest);
      
      //update screen 
      SDL_Flip(screen);

      // Free the memory allocated to temp_screen
      SDL_FreeSurface(temp_screen);
      }
// draw play on the given location
void draw_player_x(SDL_Surface* screen,int player_x, int x_dest, int y_dest)     
    {
    int  chose_image=0;                
      
    // player image                  
    if ( player_x == 1){chose_image = 4;  } ;
    if ( player_x == 2){chose_image = 39; } ;
      
    temp_screen = SDL_LoadBMP("player_12.bmp");
 
    SDL_Rect dice_dest2;
    dice_dest2.x = x_dest;
    dice_dest2.y = y_dest;
      
    SDL_Rect player_x_image;
    player_x_image.x = chose_image;
    player_x_image.y = 8;
    player_x_image.w = 19;
    player_x_image.h = 19;
    
        
    Uint32 colorkey = SDL_MapRGB( temp_screen->format, 0, 0, 0 );

    SDL_SetColorKey(temp_screen,SDL_SRCCOLORKEY, colorkey );
    
      
    SDL_BlitSurface(temp_screen, &player_x_image, screen, &dice_dest2);
    //update screen   
    SDL_Flip(screen);
    
    // Free the memory allocated to temp_screen
    SDL_FreeSurface(temp_screen);
    }

/*Roll Dice*/          
int Roll_Dice1(SDL_Surface* screen,int draw_location, int dice_value)
    { 
    int rand_num, dice_MAX=6;
    
    //random seed 
	srand( (unsigned)(time( NULL )+ dice_value*SDL_GetTicks()) );
	
    //random funcation 
    rand_num=rand()%dice_MAX; 
    
    //change zero to 3
    if (rand_num==0)rand_num=6;
    
    dice_value=rand_num;
    
    //draw dice on screen
    draw_dice(screen,rand_num,draw_location);
    
    return  dice_value;
    }
 
//draw act       
void draw_act(SDL_Surface* screen,int tile_number)
      {
      //load image to memory 
      temp_screen = SDL_LoadBMP("act.bmp");
      
      SDL_Rect dest;
      dest.x = 5;
      dest.y = 5;
      
      SDL_Rect  tile_image;
      tile_image.x = 30*tile_number;
      tile_image.y = 0;
      tile_image.w = 30;
      tile_image.h = 30;
      
      Uint32 colorkey = SDL_MapRGB( temp_screen->format, 0, 0, 0 );

      SDL_SetColorKey(temp_screen,SDL_SRCCOLORKEY, colorkey );
      
      SDL_BlitSurface(temp_screen, &tile_image, screen, &dest);
      
      //update screen 
      SDL_Flip(screen);

      // Free the memory allocated to temp_screen
      SDL_FreeSurface(temp_screen);
      }
//draw act       
void draw_table_of_track(SDL_Surface* screen)
      {
      temp_screen = SDL_LoadBMP("table_of_track.bmp");
      
    SDL_Rect dest;
    dest.x = 0;
    dest.y = 0;
      
    SDL_BlitSurface(temp_screen, NULL, screen, &dest);
    
    //update screen   
    SDL_Flip(screen);
    
    // Free the memory allocated to temp_screen
    SDL_FreeSurface(temp_screen);
    }
    
//draw Game background (the main board)
void draw_track_image(int track_num_image,SDL_Surface* screen)
      {
      //load image to memory 
      temp_screen = SDL_LoadBMP("act.bmp");
      
      SDL_Rect dest;
      dest.x = 60;
      dest.y = 60+(40*track_num_image);
      
      SDL_Rect  tile_image;
      tile_image.x = 60;
      tile_image.y = 0;
      tile_image.w = 30;
      tile_image.h = 30;
      
      Uint32 colorkey = SDL_MapRGB( temp_screen->format, 0, 0, 0 );

      SDL_SetColorKey(temp_screen,SDL_SRCCOLORKEY, colorkey );
      
      SDL_BlitSurface(temp_screen, &tile_image, screen, &dest);
      
      //update screen 
      SDL_Flip(screen);

      // Free the memory allocated to temp_screen
      SDL_FreeSurface(temp_screen);
      }


