#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <SDL.h>
#include "SDL_mixer.h"
#include "dubairace_call.h"
#include "dubairace_image.h"


/* The screen surface, joystick device */
SDL_Surface *screen = NULL;
SDL_Joystick *joy = NULL;
Mix_Chunk *sound = NULL;

int player_1_score=0,player_2_score=0;
int player_x_score[6]={0};
int player_x_location[9]={1,1,1,1,1,1,1,1,1};
int track_num=0;

int borad_location[4][26]={{0,1,2,3,4,5,10,9,8,7,6,11,12,13,14,15,20,19,18,17,16,21,22,23,24,25} //h
                          ,{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25}//z
                          ,{0,1,6,11,16,21,22,17,12,7,2,3,8,13,18,23,24,19,14,9,4,5,10,15,20,25}};//v


void score_player(int player_x,int value_num)
     {
	 int channel;    
     
     if ( player_x == 1) 
        {
         player_x_score[0]=player_x_score[0]+value_num;
         player_1_score=player_1_score+value_num;
         printf("score p_1 = %d \n",player_1_score);
        }
     if ( player_x == 2)
        {
         player_x_score[3]=player_x_score[3]+value_num;
         player_2_score=player_2_score+value_num;
         printf("score p_2 = %d \n",player_2_score);
        }
     
     if (player_x_score[0] > 6)
        {
        player_x_score[0]=player_x_score[0]-6;
        player_x_score[1]=player_x_score[1]+1;                   
        }
     if (player_x_score[1] > 6)
        {
        player_x_score[1]=player_x_score[1]-6;
        player_x_score[2]=player_x_score[2]+1;                   
        }
        
     if (player_x_score[3] > 6)
        {
        player_x_score[3]=player_x_score[3]-6;
        player_x_score[4]=player_x_score[4]+1;                   
        }
     if (player_x_score[4] > 6)
        {
        player_x_score[4]=player_x_score[4]-6;
        player_x_score[5]=player_x_score[5]+1;                   
        }
     //player 2 score
     draw_dice(screen,player_x_score[3], 115 ); //240);
     draw_dice(screen,player_x_score[4], 80 ); //205);
     draw_dice(screen,player_x_score[5], 46 ); //170);
     //player 1 score
     draw_dice(screen,player_x_score[0], 240 ); //75);
     draw_dice(screen,player_x_score[1], 205 ); //40);
     draw_dice(screen,player_x_score[2], 170 ); //5);
     
     sound = Mix_LoadWAV("dive_move.wav");
     channel = Mix_PlayChannel(-1, sound, 0);
     while(Mix_Playing(channel) != 0); 
     }      
      
void player_location(int player_x,int player_location_x)
    {
    int  x_loaction,y_location,image_x_loaction,image_y_loaction;
    int  chose_image=0;
               
    // player image                  
    if ( player_x == 1){x_loaction = 4;  } ;
    if ( player_x == 2){x_loaction = 39; } ;
    if (player_location_x >= 26)
    {
     player_location_x = 25;
     }                     

        player_location_x=borad_location[track_num][player_location_x]; 
     // 1
     if (player_location_x == 1)
        {
        image_x_loaction = x_loaction;
        image_y_loaction = 48;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 2
     else if (player_location_x == 2)
        {
        image_x_loaction = x_loaction+64;
        image_y_loaction = 48;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 3
     else if (player_location_x == 3)
        {
        image_x_loaction = x_loaction+(64*2);
        image_y_loaction = 48;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 4
     else if (player_location_x == 4)
        {
        image_x_loaction = x_loaction+(64*3);
        image_y_loaction = 48;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 5
     else if (player_location_x == 5)
        {
        image_x_loaction = x_loaction+(64*4);
        image_y_loaction = 48;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 6 ===================================================
     else if (player_location_x == 6)
        {
        image_x_loaction = x_loaction;
        image_y_loaction = 48+40;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        } 
     // 7  
     else if (player_location_x == 7)
        {
        image_x_loaction = x_loaction+64;
        image_y_loaction = 48+40;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 8
     else if (player_location_x == 8)
        {
        image_x_loaction = x_loaction+(64*2);
        image_y_loaction = 48+40;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);        
        }
     // 9
     else if (player_location_x == 9)
        {
        image_x_loaction = x_loaction+(64*3);
        image_y_loaction = 48+40;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);       
        }
     // 10
     else if (player_location_x == 10)
        {
        image_x_loaction = x_loaction+(64*4);
        image_y_loaction = 48+40;
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 11 ===========================================
     else if (player_location_x == 11)
        {
        image_x_loaction = x_loaction;
        image_y_loaction = 48+(40*2);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 12
     else if (player_location_x == 12)
        {
        image_x_loaction = x_loaction+64;
        image_y_loaction = 48+(40*2);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 13
     else if (player_location_x == 13)
        {
        image_x_loaction = x_loaction+(64*2);
        image_y_loaction = 48+(40*2);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 14
     else if (player_location_x == 14)
        {
        image_x_loaction = x_loaction+(64*3);
        image_y_loaction = 48+(40*2);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 15
     else if (player_location_x == 15)
        {
        image_x_loaction = x_loaction+(64*4);
        image_y_loaction = 48+(40*2);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 16 =====================================================
     else if (player_location_x == 16)
        {
        image_x_loaction = x_loaction;
        image_y_loaction = 48+(40*3);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 17
     else if (player_location_x == 17)
        {
        image_x_loaction = x_loaction+64;
        image_y_loaction = 48+(40*3);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 18
     else if (player_location_x == 18)
        {
        image_x_loaction = x_loaction+(64*2);
        image_y_loaction = 48+(40*3);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 19
     else if (player_location_x == 19)
        {
        image_x_loaction = x_loaction+(64*3);
        image_y_loaction = 48+(40*3);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 20
     else if (player_location_x == 20)
        {
        image_x_loaction = x_loaction+(64*4);
        image_y_loaction = 48+(40*3);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 21 =====================================================
     else if (player_location_x == 21)
        {
        image_x_loaction = x_loaction;
        image_y_loaction = 48+(40*4);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 22
     else if (player_location_x == 22)
        {
        image_x_loaction = x_loaction+64;
        image_y_loaction = 48+(40*4);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 23
     else if (player_location_x == 23)
        {
        image_x_loaction = x_loaction+(64*2);
        image_y_loaction = 48+(40*4);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 24
     else if (player_location_x == 24)
        {
        image_x_loaction = x_loaction+(64*3);
        image_y_loaction = 48+(40*4);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
     // 25
     else
        {
        image_x_loaction = x_loaction+(64*4);
        image_y_loaction = 48+(40*4);
        draw_player_x(screen,player_x,image_x_loaction,image_y_loaction);
        }
        
    }// end of player location 
     
void player_control(int player_x)
     {
      int dice_value;
      int temp_location;                  
     draw_game_background(track_num,screen);       
     dice_value=Roll_Dice1(screen,283,dice_value); 
     //printf("dice value before = %d \n",dice_value);
     
     player_x_location[player_x] = player_x_location[player_x] + dice_value;
     
     if (player_x_location[player_x] == 7 || player_x_location[player_x] == 17)
     { 
     player_x_location[player_x] = player_x_location[player_x]+ 3;
     draw_act(screen,0);
     }
     
     else if (player_x_location[player_x] == 20 || player_x_location[player_x] == 10)
     { 
     player_x_location[player_x] = player_x_location[player_x]- 3;
     draw_act(screen,1);
     }
     
     else if (player_x_location[player_x] == 13 || player_x_location[player_x] == 2)
     { 
     temp_location= player_x_location[1];                               
     player_x_location[1] = player_x_location[2];
     player_x_location[2] = temp_location;
     draw_act(screen,2);
     }
     player_location(1,player_x_location[1]);//drow player 1
     player_location(2,player_x_location[2]);//drow player 2

     score_player(player_x,dice_value);
     
     //printf("dice value after = %d \n",dice_value);
     //printf("dice = %d, P_1 location = %d\n",dice_value,player_x_location[1]);
     //printf("dice = %d, P_2 location = %d\n",dice_value,player_x_location[2]);
     }
void race_track()
     {
     int done=0,option=1;
     while (!done)
	{
    draw_table_of_track(screen); 
          
//==================================================             
       
       if ( option == 1) 
          {
          //draw_act(screen,1);
          draw_track_image(0,screen); 
          track_num=0;
          }     
       if ( option == 2) 
           {
           //draw_act(screen,2);
           draw_track_image(1,screen); 
           track_num=1;
          } 
       if ( option == 3) 
          {
          //draw_act(screen,3);
          draw_track_image(2,screen); 
          track_num=2;
          }   
       
       printf("%d \n",track_num);  
//=======================================================             
	SDL_Event event;

	/* Check for events */
	while (SDL_PollEvent (&event))
		{
		switch (event.type)
			{
				case SDL_KEYDOWN:
					/* if press Ctrl + C, terminate program */
					if ( (event.key.keysym.sym == SDLK_c) && (event.key.keysym.mod & (KMOD_LCTRL | KMOD_RCTRL)) )
					   {
                        done = 1;
                        }
					if (event.key.keysym.sym == SDLK_SPACE)
						{
                        done = 1;
                        }
                        
					/* if press up button */
					if ( event.key.keysym.sym == SDLK_UP )
					    {
                        option--;
					    if(option<=0) option=3;
                        }
                    if ( event.key.keysym.sym == SDLK_DOWN )
					    {
                        option++;
					    if(option>=4) option=1;
                        }
					break;
				case SDL_KEYUP:
					break;
				case SDL_JOYBUTTONDOWN:
					/* if press up button */
					if ( event.jbutton.button == VK_FB )
					    {
                        done = 1;
                        }                      
					if ( event.jbutton.button == VK_UP )
					    {
                        option--;
					    if(option<=0) option=3;
                        }
                    if ( event.jbutton.button == VK_DOWN )
					    {
                        option++;
					    if(option>=4) option=1;
                        }	
					break;
				case SDL_JOYBUTTONUP:
					break;
				case SDL_QUIT:
					done = 1;
					break;
				default:
					break;
			}
		}
		/* Processing */		
	}        
     }//end of race track
     
void game_control()
    {
	int done=0, dice_value =1,player_turn=1;

    draw_game_background(track_num,screen);
    player_location(1,player_x_location[1]);
    player_location(2,player_x_location[2]);
                
                            
    while (!done)
        {
	    SDL_Event event_1;
        /* Check for events */
		while (SDL_PollEvent(&event_1))
		    {
			switch (event_1.type)
			    {
				case SDL_KEYDOWN:
					/* if press Ctrl + C, terminate program */
					if ( (event_1.key.keysym.sym == SDLK_c) && (event_1.key.keysym.mod & (KMOD_LCTRL | KMOD_RCTRL)) )
						{
                        done = 1;
                        }
					if (event_1.key.keysym.sym == SDLK_SPACE)
						{
          		        if (player_x_location[2] < 25 && player_turn==1) 
                           {
                           player_control(1);
                           //player_control(dice_value,1);                      
                           player_turn = 2;
                           }
                     else if (player_x_location[2] < 25 && player_x_location[1] < 25 && player_turn == 2) 
                           {
                           player_control(2);
                           //player_control(dice_value,2);                        
                           player_turn = 1;
                           }
                           
    		            if (player_x_location[1] >= 25 && player_x_location[2] < 25) 
                           {
                           done = 1;
                           draw_tile(screen,0);
                           score_player(1,0);
                           SDL_Delay(1000);
                           printf("win\n");
                           }
    		  
    		            if (player_x_location[2] >= 25) 
                           {
                           done = 1;                           
                           draw_tile(screen,1);
                           score_player(2,0);
                           SDL_Delay(1000);
                           printf("lost\n");                  
                           }
                        }
					break;
				case SDL_KEYUP:
					break;
				case SDL_JOYBUTTONDOWN:
					/* if press Start button, terminate program */
					if ( event_1.jbutton.button == VK_FX )
					    {
						done = 1;
                        }
                    if ( event_1.jbutton.button == VK_FA )
					    {
          		        if (player_x_location[2] < 25 && player_turn==1) 
                           {
                           player_control(1);
                           //player_control(dice_value,1);                      
                           player_turn = 2;
                           }
                     else if (player_x_location[2] < 25 && player_x_location[1] < 25 && player_turn == 2) 
                           {
                           player_control(2);
                           //player_control(dice_value,2);                        
                           player_turn = 1;
                           }
                           
    		            if (player_x_location[1] >= 25 && player_x_location[2] < 25) 
                           {
                           done = 1;
                           draw_tile(screen,0);
                           score_player(1,0);
                           SDL_Delay(1000);
                           printf("win\n");
                           }
    		  
    		            if (player_x_location[2] >= 25) 
                           {
                           done = 1;                           
                           draw_tile(screen,1);
                           score_player(2,0);
                           SDL_Delay(1000);
                           printf("lost\n");                  
                           }
                        }	
					break;
				case SDL_JOYBUTTONUP:
					break;
				case SDL_QUIT:
					done = 1;
					break;
				default:
					break;
			    }//end fo switch
		    } //end of event while 
                
        }// end of  while loop
        
    } // enf of function control   
//====================================================================
int main (int argc, char *argv[])
{
	int done,dice_value;

	/* Initialize SDL */
	if (SDL_Init (SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK) < 0) {
		fprintf (stderr, "Couldn't initialize SDL: %s\n", SDL_GetError ());
		exit (1);
	}
	atexit (Terminate);

	SDL_ShowCursor(SDL_DISABLE);

	/* Set 320x240 16-bits video mode */
	screen = SDL_SetVideoMode (320, 240, 16, SDL_SWSURFACE);
	if (screen == NULL) {
		fprintf (stderr, "Couldn't set 320x240x16 video mode: %s\n", SDL_GetError ());
		exit (2);
	}

	/* Check and open joystick device */
	if (SDL_NumJoysticks() > 0) {
		joy = SDL_JoystickOpen(0);
		if(!joy) {
			fprintf (stderr, "Couldn't open joystick 0: %s\n", SDL_GetError ());
		}
	}
Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, AUDIO_S16, MIX_DEFAULT_CHANNELS, 1024);

#ifdef GP2X
	/* Only use GP2X code here */
#endif

#ifdef WIN32
	/* Only use Windows code here */
	SDL_WM_SetCaption( "Dubai Race 0.3.6", "DuabiRace.ico" );
#endif
    draw_Splash_screen(screen);

    draw_table_of_contant(screen);
	done = 0;

	while (!done)
	{
	SDL_Event event;

	/* Check for events */
	while (SDL_PollEvent (&event))
		{
		switch (event.type)
			{
				case SDL_KEYDOWN:
					/* if press Ctrl + C, terminate program */
					if ( (event.key.keysym.sym == SDLK_c) && (event.key.keysym.mod & (KMOD_LCTRL | KMOD_RCTRL)) )
					   {
                        draw_Goodbye(screen);
						SDL_Delay(1000);
                        done = 1;
                        }
					if (event.key.keysym.sym == SDLK_SPACE)
						{
                        Mix_FreeChunk(sound);
                        dice_value=1;
                        player_x_location[1]=1;
                        player_x_location[2]=1;
                        player_x_score[0]=0;
                        player_x_score[1]=0;
                        player_x_score[2]=0;
                        player_x_score[3]=0;
                        player_x_score[4]=0;
                        player_x_score[5]=0;
                        player_1_score=0;
                        player_2_score=0;
                        race_track(track_num);
                        game_control();
                        draw_table_of_contant(screen);
                        }
					break;
				case SDL_KEYUP:
					break;
				case SDL_JOYBUTTONDOWN:
					/* if press Start button, terminate program */
					if ( event.jbutton.button == VK_START )
					    {
                        draw_Goodbye(screen);
					    SDL_Delay(3000);
						done = 1;
                        }
                    if ( event.jbutton.button == VK_FB )
					    {
                        Mix_FreeChunk(sound); 
                        dice_value=1;
                        player_x_location[1]=1;
                        player_x_location[2]=1;
                        player_x_score[0]=0;
                        player_x_score[1]=0;
                        player_x_score[2]=0;
                        player_x_score[3]=0;
                        player_x_score[4]=0;
                        player_x_score[5]=0;
                        player_1_score=0;
                        player_2_score=0; 
                        race_track(track_num);
                        game_control();
                        draw_table_of_contant(screen);
                        }	
					break;
				case SDL_JOYBUTTONUP:
					break;
				case SDL_QUIT:
					done = 1;
					break;
				default:
					break;
			}
		}
		/* Processing */		
	}
	return 0;
}
